<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: src/Mesh.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_mesh_8hpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Mesh.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_mesh_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * eduRayTracer - An Educational Ray Tracing Software Package</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Contributor(s): Pedro Santana - ISCTE-IUL (2014-2016)</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef _H_Mesh_</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define _H_Mesh_</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_surface_8hpp.html">Surface.hpp</a>&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_ray_8hpp.html">Ray.hpp</a>&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_triangle_8hpp.html">Triangle.hpp</a>&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;stdlib.h&gt;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &lt;fstream&gt;</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;sstream&gt;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno"><a class="line" href="class_mesh.html">   19</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_mesh.html">Mesh</a> : <span class="keyword">public</span> <a class="code" href="class_surface.html">Surface</a>{</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="class_mesh.html#acbef3f84de109c5f89ee4aa377a3657c">   24</a></span>&#160;    std::vector&lt;Surface*&gt; <a class="code" href="class_mesh.html#acbef3f84de109c5f89ee4aa377a3657c">surfaces</a>;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno"><a class="line" href="class_mesh.html#ab0f87ac2cccc51a28e2e296c1e665609">   26</a></span>&#160;    std::vector&lt;std::vector&lt;Surface*&gt;&gt; <a class="code" href="class_mesh.html#ab0f87ac2cccc51a28e2e296c1e665609">verts</a>;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    </div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_mesh.html#afca381025e36aeaf6dcab4f8aa89113c">transform</a>();</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_mesh.html#a3600172f6279d1d50bbecf3abbb7b0bd">normals_at_vertexes</a>();</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;       </div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <a class="code" href="class_mesh.html#a580c671b9f4f22257a82c5ac252e311c">Mesh</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* filename, <a class="code" href="class_material.html">Material</a> *_m, <span class="keywordtype">bool</span> _smooth_shading);</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    </div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    </div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="class_mesh.html#ae2598c2ab155e0ad3182798a5c8efbc0">   50</a></span>&#160;    <a class="code" href="class_mesh.html#ae2598c2ab155e0ad3182798a5c8efbc0">Mesh</a> (std::string _id, <span class="keyword">const</span> <span class="keywordtype">char</span>* filename, <a class="code" href="class_material.html">Material</a> *<a class="code" href="class_surface.html#a99bb89c6eeea7dd90b3fda098b51422b">m</a>, <span class="keywordtype">bool</span> _smooth_shading) : <a class="code" href="class_mesh.html">Mesh</a> (filename, m, _smooth_shading){</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        <span class="keywordtype">id</span> = _id;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    }</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_mesh.html#a3a5773b7b3f1457e0e1667a8b5c49975">setTransform</a>(<a class="code" href="class_transform.html">Transform</a> *_tf);</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="class_mesh.html#a216201cebabdd7341983615e19239c94">setMaterial</a>(<a class="code" href="class_material.html">Material</a> *_m);</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="class_mesh.html#afa6d51dcd0b3636a992b509621afef87">addSurfaces</a>(std::vector&lt;Surface*&gt; &amp;objects);</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_mesh.html#abb73d5cb7028e1138cb714b34d01bbca">hit</a>(<span class="keyword">const</span> <a class="code" href="class_ray.html">Ray</a> &amp;r, <a class="code" href="structhit__rec.html">hit_rec</a> &amp;h_r, <span class="keywordtype">double</span> t_min, <span class="keywordtype">double</span> t_max);</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_mesh.html#a0560f1ba7ad6b24a176ab302723b0fa2">bounding_box</a>();</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="class_box.html">Box</a> <a class="code" href="class_mesh.html#acc5d10d24bcc8b127ce9033cf01cb73b">getBBox</a>();</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_mesh.html#aed5f345616e0d840eb59e1f4a0c77df9">getCentroid</a>();</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;};</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="class_mesh_html_a3a5773b7b3f1457e0e1667a8b5c49975"><div class="ttname"><a href="class_mesh.html#a3a5773b7b3f1457e0e1667a8b5c49975">Mesh::setTransform</a></div><div class="ttdeci">void setTransform(Transform *_tf)</div><div class="ttdoc">Associates a Transform node to this Mesh. The method transform() can then be used to change the Mesh&amp;#39;...</div><div class="ttdef"><b>Definition:</b> Mesh.cpp:115</div></div>
<div class="ttc" id="class_mesh_html"><div class="ttname"><a href="class_mesh.html">Mesh</a></div><div class="ttdoc">A class to create and manipulate triangular meshes. </div><div class="ttdef"><b>Definition:</b> Mesh.hpp:19</div></div>
<div class="ttc" id="class_mesh_html_ab0f87ac2cccc51a28e2e296c1e665609"><div class="ttname"><a href="class_mesh.html#ab0f87ac2cccc51a28e2e296c1e665609">Mesh::verts</a></div><div class="ttdeci">std::vector&lt; std::vector&lt; Surface * &gt; &gt; verts</div><div class="ttdef"><b>Definition:</b> Mesh.hpp:26</div></div>
<div class="ttc" id="class_mesh_html_ae2598c2ab155e0ad3182798a5c8efbc0"><div class="ttname"><a href="class_mesh.html#ae2598c2ab155e0ad3182798a5c8efbc0">Mesh::Mesh</a></div><div class="ttdeci">Mesh(std::string _id, const char *filename, Material *m, bool _smooth_shading)</div><div class="ttdoc">A constructor to build a Mesh from an .obj file. </div><div class="ttdef"><b>Definition:</b> Mesh.hpp:50</div></div>
<div class="ttc" id="class_surface_html"><div class="ttname"><a href="class_surface.html">Surface</a></div><div class="ttdoc">A base class for every geometry class (e.g., Sphere, Triangle, Mesh). </div><div class="ttdef"><b>Definition:</b> Surface.hpp:40</div></div>
<div class="ttc" id="_ray_8hpp_html"><div class="ttname"><a href="_ray_8hpp.html">Ray.hpp</a></div></div>
<div class="ttc" id="class_mesh_html_aed5f345616e0d840eb59e1f4a0c77df9"><div class="ttname"><a href="class_mesh.html#aed5f345616e0d840eb59e1f4a0c77df9">Mesh::getCentroid</a></div><div class="ttdeci">virtual Vec getCentroid()</div><div class="ttdoc">Returns the centroid of this mesh. </div><div class="ttdef"><b>Definition:</b> Mesh.cpp:151</div></div>
<div class="ttc" id="class_mesh_html_a0560f1ba7ad6b24a176ab302723b0fa2"><div class="ttname"><a href="class_mesh.html#a0560f1ba7ad6b24a176ab302723b0fa2">Mesh::bounding_box</a></div><div class="ttdeci">void bounding_box()</div><div class="ttdoc">Computes the bounding box of this mesh. </div><div class="ttdef"><b>Definition:</b> Mesh.cpp:159</div></div>
<div class="ttc" id="class_transform_html"><div class="ttname"><a href="class_transform.html">Transform</a></div><div class="ttdoc">A class to handle rigid transformations. </div><div class="ttdef"><b>Definition:</b> Transform.hpp:17</div></div>
<div class="ttc" id="class_mesh_html_acbef3f84de109c5f89ee4aa377a3657c"><div class="ttname"><a href="class_mesh.html#acbef3f84de109c5f89ee4aa377a3657c">Mesh::surfaces</a></div><div class="ttdeci">std::vector&lt; Surface * &gt; surfaces</div><div class="ttdoc">Vector of pointers to the Surface objects that compose this Mesh. </div><div class="ttdef"><b>Definition:</b> Mesh.hpp:24</div></div>
<div class="ttc" id="class_mesh_html_abb73d5cb7028e1138cb714b34d01bbca"><div class="ttname"><a href="class_mesh.html#abb73d5cb7028e1138cb714b34d01bbca">Mesh::hit</a></div><div class="ttdeci">bool hit(const Ray &amp;r, hit_rec &amp;h_r, double t_min, double t_max)</div><div class="ttdef"><b>Definition:</b> Mesh.cpp:128</div></div>
<div class="ttc" id="class_material_html"><div class="ttname"><a href="class_material.html">Material</a></div><div class="ttdoc">A class to create and manipulate surface materials. </div><div class="ttdef"><b>Definition:</b> Material.hpp:19</div></div>
<div class="ttc" id="class_mesh_html_acc5d10d24bcc8b127ce9033cf01cb73b"><div class="ttname"><a href="class_mesh.html#acc5d10d24bcc8b127ce9033cf01cb73b">Mesh::getBBox</a></div><div class="ttdeci">virtual Box getBBox()</div><div class="ttdoc">Returns the bounding box of this mesh. </div><div class="ttdef"><b>Definition:</b> Mesh.cpp:147</div></div>
<div class="ttc" id="class_mesh_html_afa6d51dcd0b3636a992b509621afef87"><div class="ttname"><a href="class_mesh.html#afa6d51dcd0b3636a992b509621afef87">Mesh::addSurfaces</a></div><div class="ttdeci">virtual void addSurfaces(std::vector&lt; Surface *&gt; &amp;objects)</div><div class="ttdoc">Adds all triangles (their pointers, actually) belonging to this Mesh to a given vector of surfaces...</div><div class="ttdef"><b>Definition:</b> Mesh.cpp:123</div></div>
<div class="ttc" id="class_mesh_html_a580c671b9f4f22257a82c5ac252e311c"><div class="ttname"><a href="class_mesh.html#a580c671b9f4f22257a82c5ac252e311c">Mesh::Mesh</a></div><div class="ttdeci">Mesh(const char *filename, Material *_m, bool _smooth_shading)</div><div class="ttdoc">A constructor to build a Mesh from an .obj file. </div><div class="ttdef"><b>Definition:</b> Mesh.cpp:30</div></div>
<div class="ttc" id="class_surface_html_a99bb89c6eeea7dd90b3fda098b51422b"><div class="ttname"><a href="class_surface.html#a99bb89c6eeea7dd90b3fda098b51422b">Surface::m</a></div><div class="ttdeci">Material * m</div><div class="ttdoc">Material associated to this surface. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:59</div></div>
<div class="ttc" id="class_mesh_html_a3600172f6279d1d50bbecf3abbb7b0bd"><div class="ttname"><a href="class_mesh.html#a3600172f6279d1d50bbecf3abbb7b0bd">Mesh::normals_at_vertexes</a></div><div class="ttdeci">void normals_at_vertexes()</div><div class="ttdoc">Triggers the computation of the normal vectors for all Surface objects stored in the Vector surfaces...</div><div class="ttdef"><b>Definition:</b> Mesh.cpp:19</div></div>
<div class="ttc" id="_triangle_8hpp_html"><div class="ttname"><a href="_triangle_8hpp.html">Triangle.hpp</a></div></div>
<div class="ttc" id="class_vec_html"><div class="ttname"><a href="class_vec.html">Vec</a></div><div class="ttdoc">A class to create and manipulate 3D vectors. These can be used to store positions, normals, and RGB triplets. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:16</div></div>
<div class="ttc" id="class_mesh_html_afca381025e36aeaf6dcab4f8aa89113c"><div class="ttname"><a href="class_mesh.html#afca381025e36aeaf6dcab4f8aa89113c">Mesh::transform</a></div><div class="ttdeci">void transform()</div><div class="ttdoc">Triggers the application of all transforms defined for all Surface and Light objects with setTransfor...</div><div class="ttdef"><b>Definition:</b> Mesh.cpp:8</div></div>
<div class="ttc" id="class_box_html"><div class="ttname"><a href="class_box.html">Box</a></div><div class="ttdef"><b>Definition:</b> Box.hpp:12</div></div>
<div class="ttc" id="_surface_8hpp_html"><div class="ttname"><a href="_surface_8hpp.html">Surface.hpp</a></div></div>
<div class="ttc" id="class_mesh_html_a216201cebabdd7341983615e19239c94"><div class="ttname"><a href="class_mesh.html#a216201cebabdd7341983615e19239c94">Mesh::setMaterial</a></div><div class="ttdeci">virtual void setMaterial(Material *_m)</div><div class="ttdoc">Sets the material for this Mesh. </div><div class="ttdef"><b>Definition:</b> Mesh.cpp:108</div></div>
<div class="ttc" id="class_ray_html"><div class="ttname"><a href="class_ray.html">Ray</a></div><div class="ttdoc">A class to create and manipulate 3D rays. </div><div class="ttdef"><b>Definition:</b> Ray.hpp:12</div></div>
<div class="ttc" id="structhit__rec_html"><div class="ttname"><a href="structhit__rec.html">hit_rec</a></div><div class="ttdoc">A structure used to hold information regarding ray-surface intersection events. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:20</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="_mesh_8hpp.html">Mesh.hpp</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
